/*

 UNLu
 Departamento de Ciencias Basicas
 Division Estadistica y Sistemas
 Licenciatura en Sistemas de Informacion
 11411 Base de Datos
 Lic. Guillermo Cherencio

 Trabajo Practico I "Listado Especifico - Listado Generico"
 Ejercicio I
 Implementacion de archivo relativo usando compilador GNU C/C++ GCC for Windows (cygwin)

 =============script de compilacion, linkedicion y ejecucion=============================
#!/bin/sh
#
# script para compilar aplicacion bdtp11.c 
#
#                Atte. Guillermo Cherencio
#                UNLu
#
echo compilo - enlazo - ejecuto
gcc -Wall -g bdtp11.c -o ../../bin/bdtp11.exe -I../../include -L../../lib -lrelativo -lconsola
../../bin/bdtp11.exe
 ==========================================================================================

 =============estructura de directorios de trabajo=========================================
C:.
+---bin
+---include
+---lib
+---obj
|   \---lib1
\---src
    +---bdtp1
    +---lib1
    \---prj1
 ==========================================================================================
 
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libconsola.h"
#include "librelativo.h"

/* parametros */

#define ARCHIVO "datos.dat"
#define MAXREG 1000
#define REGLEN 65 // 1 + 30 + 30 + 4  tamao registro en disco

/* estructura de registro */

// tamao de registro en memoria: el sizeof(rg) es 68

typedef struct {
   char est;
   char ape[30];
   char nom[30];
   int cod;
} rg;

/* prototipo de funciones */
void crear();
void ingresar();
void borrar();
void listar();
void mostrar(rg *);
void tipear(rg *);
int validar(rg *);
void rellenar(rg *);

void parseBuf(char *,rg *);
void parseReg(rg *,char *);

/************************************************************************************
  COMIENZO PROGRAMA
************************************************************************************/
int main() {
  int op;
  char *titulo = "Listado Especifico - Generico (1)";
  // opcion "" indica que se termina el arreglo de opciones de menu
  char *opc[] = { "Crear Archivo","Altas y Modificaciones","Bajas","Listar", "" };
  do {
     linea();
     op=smenu(titulo,opc);
     switch(op) {
        case 1: crear();   break;
        case 2: ingresar();break;
        case 3: borrar();  break;
        case 4: listar();  break;
     }
  } while(op != 99);
  return 0;
}
/************************************************************************************
  FIN PROGRAMA
************************************************************************************/

/* funciones alto nivel */

void crear() {
   rel_fd *f = rel_decl(ARCHIVO,MAXREG,REGLEN);
   if ( preguntarSN("Genera un Archivo nuevo?\nLos Datos Actuales se perderan.")) {
      if ( rel_crear(f) ) printf("Archivo %s Generado Ok\n",f->filename);
   }
   rel_finit(f);
}


void ingresar() {
   rel_fd *f = rel_decl(ARCHIVO,MAXREG,REGLEN);
   rel_init(f);
   rg regm, regf;
   int pos;
   do {
       pos = getIntP("Posicion (-1 para salir): ");
       if ( pos != -1 ) {
          if ( pos >= 0 && pos < f->maxreg ) {
             if ( rel_leer(f,pos) ) {
                parseReg(&regf,f->buffer);
                if ( regf.est == REL_OCUPADO ) {
                   printf("Posicion ya ocupada!\n");
                   mostrar(&regf);
                }
                regm.est = REL_OCUPADO;
                tipear(&regm);
                if ( validar(&regm) ) {
                   if (preguntarSN("Cambia esta Posicion?")) {
                      parseBuf(f->buffer,&regm);
                      rel_grabar(f,pos);
                   }
                }
             }
          } else {
             printf("%d es una posicion no valida (%d - %d)\n",pos,0,f->maxreg);
          }
       }
   } while(pos != -1);
   rel_finit(f);
}

void borrar() {
   rel_fd *f = rel_decl(ARCHIVO,MAXREG,REGLEN);
   rel_init(f);
   rg regf;
   int pos;
   do {
       pos = getIntP("Posicion (-1 para salir): ");
       if ( pos != -1 ) {
          if ( pos >= 0 && pos < f->maxreg ) {
             if ( rel_leer(f,pos) ) {
                parseReg(&regf,f->buffer);
                if ( regf.est == REL_OCUPADO ) {
                   mostrar(&regf);
                   if (preguntarSN("Borra esta Posicion?")) {
                      regf.est = REL_LIBRE;
                      parseBuf(f->buffer,&regf);
                      rel_grabar(f,pos);
                   }
                } else {
                   printf("%d es una posicion no ocupada\n",pos);
                }
             }
          } else {
             printf("%d es una posicion no valida (%d - %d)\n",pos,0,f->maxreg);
          }
       }
   } while(pos != -1);
   rel_finit(f);
}

void listar() {
   rel_fd *f = rel_decl(ARCHIVO,MAXREG,REGLEN);
   rel_init(f);
   rg reg;
   int pos=0;
   printf("   # Cod. Apellido                       Nombre\n");
   while ( rel_leer(f,pos) ) {
      parseReg(&reg,f->buffer);
      if ( reg.est == REL_OCUPADO ) {
         printf("%4d %4d %-30s %-30s\n",pos,reg.cod,reg.ape,reg.nom);
      }
      pos++;
   }
   rel_finit(f);
}

void mostrar(rg *reg) {
   printf("Codigo: %d\n",reg->cod);
   printf("Apellido: %s\n",reg->ape);
   printf("Nombre: %s\n",reg->nom);
}

void tipear(rg *reg) {
   reg->cod = getIntP("Codigo: ");
   strcpy(reg->ape,getStringP("Apellido: "));
   strcpy(reg->nom,getStringP("Nombre: "));
}

int validar(rg *reg) {
   int ret=1;
   if ( !(reg->cod > 0 && reg->cod <= 9999) ) { 
      printf("Codigo debe ser un numero entre %d y %d\n",1,9999);
      ret=0;
   } else if ( reg->ape == NULL ) {
      printf("Debe ingresar Apellido\n");
      ret=0;
   } else if ( reg->nom == NULL ) {
      printf("Debe ingresar Nombre\n");
      ret=0;
   }
   return ret;
}

void parseBuf(char *buf,rg *reg) {
   int i=0,w,largo;
   char *p;
   buf[i++] = reg->est;
   largo=strlen(reg->ape);
   for(w=0;w<largo;w++,i++) buf[i] = reg->ape[w];
   largo=sizeof(reg->ape);
   for(;w<largo;w++,i++) buf[i] = '\0';
   largo=strlen(reg->nom);
   for(w=0;w<largo;w++,i++) buf[i] = reg->nom[w];
   largo=sizeof(reg->nom);
   for(;w<largo;w++,i++) buf[i] = '\0';
   p = buf+i;
   w = reg->cod;
   memcpy(p,&w,sizeof(int));
//   printf("parseBuf(): ");for(w=0;w<i;w++) printf("%c",buf[w]);printf("\n");
}

void parseReg(rg *reg,char *buf) {
   int i=0,w;
   char *p;
   reg->est = buf[i++];
   for(w=0;w<sizeof(reg->ape);w++,i++) reg->ape[w] = buf[i];reg->ape[w-1]='\0';
   for(w=0;w<sizeof(reg->nom);w++,i++) reg->nom[w] = buf[i];reg->nom[w-1]='\0';
   p = buf+i;
   memcpy(&w,p,sizeof(int));
   reg->cod = w;
//   printf("parseReg(): %c %s %s %d\n",reg->est,reg->ape,reg->nom,reg->cod);
}

