/*

 UNLu
 Departamento de Ciencias Basicas
 Division Estadistica y Sistemas
 Licenciatura en Sistemas de Informacion
 11411 Base de Datos
 Lic. Guillermo Cherencio

 Trabajo Practico I "Listado Especifico - Listado Generico"
 Ejercicio III
 Abm sobre archivo relativo utilizando solo direcciones relativas
 Similar al ejercicio 1, pero esta vez es el propio usuario quien define la estructura
 del archivo
 Implementacion de archivo relativo usando compilador GNU C/C++ GCC for Windows (cygwin)

 =============script de compilacion, linkedicion y ejecucion=============================
#!/bin/sh
#
# script para compilar aplicacion bdtp13.c 
#
#                Atte. Guillermo Cherencio
#                UNLu
#
echo compilo - enlazo - ejecuto
gcc -Wall -g bdtp13.c libtp1.c -o ../../bin/bdtp13.exe -I../../include -L../../lib -lmilib01
../../bin/bdtp13.exe
 ==========================================================================================

 =============estructura de directorios de trabajo=========================================
C:.
+---bin
+---include
+---lib
+---obj
|   \---lib1
\---src
    +---bdtp1
    +---lib1
    \---prj1
 ==========================================================================================
 
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libtp1.h"

/* parametros */

#define LIBRE   '0'
#define OCUPADO '1'
#define ESTRUCTURA "datos3.def"
#define ARCHIVO    "datos3.dat"
#define LISTADO    "datos3.html"
#define MAXREG 1000
#define MAXLENCMP 255
#define PRIMERCMP 1 // posicion del primer campo definido por el usuario

/* estructura de registro */

// estructura de registro de la estructura 

typedef struct {
   char campo[MAXLENCMP];
   int largo;
} rge;

rge *st = NULL;
int nitems = -1;
long reglen = -1L;

/* prototipo de funciones */
void definir();
void ingresar();
void borrar();
void listar();

void mostrar(char *reg[]);
void tipear(char *reg[]);
int validar(char *reg[]);
void alocar(char *reg[]);
void finalocar(char *reg[]);
void limpiar(char *reg[]);
void parseBuf(char *buff,char *reg[]);
void parseReg(char *reg[],char *buff);
int leer(FILE *fp,int pos,char *reg[]);
int grabar(FILE *fp,int pos,char *reg[]);
int apuntar(FILE *fp,long pos);

int cargar();
void descargar();
int validarcampo(char *);
int estacargado();

int puedotrabajar();


/************************************************************************************
  COMIENZO PROGRAMA
************************************************************************************/
int main() {
  int op;
  char *titulo = "Listado Especifico - Generico (3)";
  // opcion "" indica que se termina el arreglo de opciones de menu
  char *opc[] = { "Definir Archivo","Altas y Modificaciones","Bajas","Listar", "" };
  /****************************************************************************************************
    para evitar el trabajo de hacer switch y preguntar por cada opcion elegida para ejecutar funcion
    creo arreglo con puntero a funciones y se lo paso a menu() para que realice las ejecuciones
    segun lo indicado por el usuario
  ****************************************************************************************************/
  void ((*pfuncion[]) ()) = { definir, ingresar, borrar, listar };
  cargar();
  do {
     op=menu(titulo,opc,pfuncion);
  } while(op != 99);
  return 0;
}
/************************************************************************************
  FIN PROGRAMA
************************************************************************************/

/* funciones alto nivel */

void definir() {
   if ( !preguntarSN("Genera nuevo Archivo?\nLos Datos Actuales se perderan.")) return;
   if ( estacargado() ) descargar();
   FILE *fp = fopen(ESTRUCTURA,"w");
   if ( fp != NULL ) {
      char *campo;
      int largo,ingreso=1;
      reglen=1L;  // ya estoy sumando un byte para estado
      nitems=1; // ya estoy contando el campo de estado
      fprintf(fp,"%s\t%d\n","est",1); // doy de alta el campo estado
      do {
         campo = NULL;
         do {
            if ( campo != NULL ) free(campo);
            campo = getStringP("Campo (-1 para Salir):");
         } while ( !validarcampo(campo) );
         ingreso=(strcmp(campo,"-1") != 0);
         if ( ingreso ) {
            do {
               largo = getIntP("Longitud: ");
            } while ( largo < 1 );
            fprintf(fp,"%s\t%d\n",campo,largo);
            reglen+=largo;
            nitems++;
         }
         free(campo);
      } while ( ingreso );
      fclose(fp);
      if ( nitems > 1 ) { // si al menos definio un campo...
         // cargo en memoria estructura
         if ( cargar() ) {
            // creo archivo de datos segun estructura ingresada
            if ( (fp = fopen(ARCHIVO,"w")) != NULL ) {
               char *reg[nitems];
               int pos=0;
               alocar(reg);
                  limpiar(reg);
                  reg[0][0] = LIBRE;
                  while ( grabar(fp,pos,reg) ) pos++;
               finalocar(reg);
               fclose(fp);
            } else {
               printf("definir(): %s no pudo ser creado\n",ARCHIVO);
            }
         } // ( cargar() )
      } else {
         // no hay calculo de total de items/campos ni tampoco estructura cargada en memoria
         printf("No ha definido ningun campo, el sistema no puede trabajar\n");
         // borrar estructura definida con campo estado
         fp = fopen(ESTRUCTURA,"w");fclose(fp);
      }
   } else {
      printf("definir(): %s no pudo ser creado\n",ESTRUCTURA);
   }
}

void ingresar() {
   if ( !puedotrabajar() ) return;
   FILE *fp = fopen(ARCHIVO,"r+");
   if ( fp != NULL ) {
      char *reg[nitems];
      alocar(reg);
      int pos;
      do {
          pos = getIntP("Posicion (-1 para salir): ");
          if ( pos != -1 ) {
             if ( pos >= 0 && pos < MAXREG ) {
                if ( leer(fp,pos,reg) ) {
                   if ( reg[0][0] == OCUPADO ) {
                      printf("Posicion ya ocupada!\n");
                      mostrar(reg);
                   }
                   limpiar(reg);
                   reg[0][0] = OCUPADO;
                   tipear(reg);
                   if ( validar(reg) ) {
                      if (preguntarSN("Cambia esta Posicion?")) {
                         grabar(fp,pos,reg);
                      }
                   }
                }
             } else {
                printf("%d es una posicion no valida (%d - %d)\n",pos,0,MAXREG-1);
             }
          }
      } while(pos != -1);
      finalocar(reg);
      fclose(fp);
   } else {
      printf("ingresar(): %s no pudo ser abierto\n",ARCHIVO);
   }
}

void borrar() {
   if ( !puedotrabajar() ) return;
   FILE *fp = fopen(ARCHIVO,"r+");
   if ( fp != NULL ) {
      char *reg[nitems];
      alocar(reg);
      int pos;
      do {
          pos = getIntP("Posicion (-1 para salir): ");
          if ( pos != -1 ) {
             if ( pos >= 0 && pos < MAXREG ) {
                if ( leer(fp,pos,reg) ) {
                   if ( reg[0][0] == OCUPADO ) {
                      mostrar(reg);
                      if (preguntarSN("Borra esta Posicion?")) {
                         reg[0][0] = LIBRE;
                         grabar(fp,pos,reg);
                      }
                   } else {
                      printf("%d es una posicion no ocupada\n",pos);
                   }
                }
             } else {
                printf("%d es una posicion no valida (%d - %d)\n",pos,0,MAXREG-1);
             }
          }
      } while(pos != -1);
      finalocar(reg);
      fclose(fp);
   } else {
      printf("borrar(): %s no pudo ser abierto\n",ARCHIVO);
   }
}

void listar() {
   if ( !puedotrabajar() ) return;
   FILE *fp = fopen(ARCHIVO,"r");
   if ( fp != NULL ) {
      FILE *fpo = fopen(LISTADO,"w");
      if ( fp != NULL ) {
         int pos=0,ni;
         char *reg[nitems];
         alocar(reg);
         fprintf(fpo,"<html><title>UNLu - Lic. Sistemas de Informacion - 11411 Base de Datos</title>\n"); 
         fprintf(fpo,"<body><table border=1><tr><td colspan=%d><center><b>%s</b></center></td></tr>\n",nitems,ARCHIVO); 
         fprintf(fpo,"<tr><td><b>Pos#</b></td>");
         for(ni=PRIMERCMP;ni<nitems;ni++) fprintf(fpo,"<td><b>%s</b></td>",st[ni].campo);
         fprintf(fpo,"</tr>\n");
         while ( leer(fp,pos,reg) ) {
            if ( reg[0][0] == OCUPADO ) {
               fprintf(fpo,"<tr><td>%4d</td>",pos);
               for(ni=PRIMERCMP;ni<nitems;ni++) fprintf(fpo,"<td>%s</td>",reg[ni]);
               fprintf(fpo,"</tr>\n");
            }
            pos++;
         }
         fprintf(fpo,"</table></body>\n</html>\n"); 
         finalocar(reg);
         fclose(fpo);
         printf("Listado guardado en %s\n",LISTADO);
      } else {
         printf("listar(): %s no pudo ser abierto\n",LISTADO);
      }
      fclose(fp);
   } else {
      printf("listar(): %s no pudo ser abierto\n",ARCHIVO);
   }
}

/* funciones de bajo nivel */

void mostrar(char *reg[]) {
   int ni;
   for(ni=PRIMERCMP;ni<nitems;ni++) printf("%s: %s\n",st[ni].campo,reg[ni]);
}

void tipear(char *reg[]) {
   int ni;
   char *valor;
   for(ni=PRIMERCMP;ni<nitems;ni++) {
      // prompt
      printf("%s:",st[ni].campo);
      // ingreso
      valor = getString();
      if ( valor != NULL ) {
         if ( strlen(valor) > st[ni].largo ) printf("tipear(): [%s]\nson demasiados caracteres, seran truncados a %d caracteres\n",valor,st[ni].largo);
         strncpy(reg[ni],valor,st[ni].largo);
         free(valor);
      } else {
         printf("tipear(): Error en asignacion de memoria para ingresar %s\n",st[ni].campo);
         strncpy(reg[ni],"",st[ni].largo);
      }
   }
}

int validar(char *reg[]) {
   int ret=1,ni;
   for(ni=PRIMERCMP;ni<nitems;ni++) {
      if (  reg[ni] == NULL ) {
         printf("Debe Ingresar algun valor para %s\n",st[ni].campo);
         ret=0;
      } else if ( strlen(reg[ni]) == 0 ) {
         printf("Debe Ingresar al menos %d caracteres para %s\n",st[ni].largo,st[ni].campo);
         ret=0;
      } else if ( strlen(reg[ni]) > st[ni].largo ) {
         printf("No puede Ingresar mas de %d caracteres para %s\n",st[ni].largo,st[ni].campo);
         ret=0;
      }
   }
   return ret;
}

void limpiar(char *reg[]) {
   int n,i;
   for(n=0;n<nitems;n++) {
      if ( reg[n] != NULL ) {
         for(i=0;i<st[n].largo;i++) reg[n][i]=' ';reg[n][i] = '\0';
      } else {
         printf("limpiar(): Error en asignacion de memoria (limpiar())\n");
      }
   }
}

void alocar(char *reg[]) {
   int n;
   for(n=0;n<nitems;n++) {
      reg[n] = (char *) calloc(st[n].largo+1,sizeof(char));
      if ( reg[n] == NULL ) printf("alocar(): Error en asignacion de memoria (alocar())\n");
   }
}

void finalocar(char *reg[]) {
   int n;
   for(n=0;n<nitems;n++) if ( reg[n] != NULL ) free(reg[n]);
}

int leer(FILE *fp,int pos,char *reg[]) {
   char buf[reglen];
   if (!(pos >= 0 && pos < MAXREG)) return 0;
   if ( apuntar(fp,(long) pos*(reglen)) ) {
      if ( fread(buf,1,reglen,fp) == reglen) {
         parseReg(reg,buf);
         return 1;
      } else {
         printf("leer(): Error al intentar leer registro %d en %s\n",pos,ARCHIVO);
      }
   }
   return 0;
}

int grabar(FILE *fp,int pos,char *reg[]) {
   char buf[reglen];
   if (!(pos >= 0 && pos < MAXREG)) return 0;
   if ( apuntar(fp,(long) pos*(reglen)) ) {
      parseBuf(buf,reg);
      if ( fwrite(buf,1,reglen,fp) == reglen ) {
         return 1;
      } else {
         printf("grabar(): Error al intentar grabar registro %d en %s\n",pos,ARCHIVO);
      }
   } 
   return 0;
}

int apuntar(FILE *fp,long pos) {
   if ( ftell(fp) != pos ) {
      if ( fseek(fp,pos,SEEK_SET) == 0 ) {
         return 1;
      } else {
         printf("apuntar(): Error al intentar posicionarse en %s\n",ARCHIVO);
         return 0;
      }
   } else return 1;
}

void parseBuf(char *buf,char *reg[]) {
   int i=0,w,ni;
   for(ni=0;ni<nitems;ni++) {
      for(w=0;w<strlen(reg[ni]);w++,i++) buf[i] = reg[ni][w];
      for(;w<st[ni].largo;w++,i++) buf[i] = ' ';
   }
}

void parseReg(char *reg[],char *buf) {
   int i=0,w,ni;
   for(ni=0;ni<nitems;ni++) {
      for(w=0;w<st[ni].largo;w++,i++) reg[ni][w] = buf[i];
   }
}

// carga dinamicamente estructura de campos y cantidad de campos en memoria
int cargar() {
   int i,ret=1;
   FILE *fp;
   if ( (fp = fopen(ESTRUCTURA,"r")) != NULL ) {
      char cmp[MAXLENCMP];int lrg=0;
      nitems=0;
      while ( fscanf(fp,"%s\t%d\n",(char * ) &cmp,&lrg) != EOF ) nitems++;
      fclose(fp);
      if ( nitems > 1 ) {
         // si ya estaba cargado de antes, libero memoria y vuelvo a cargar
         if ( st != NULL ) free(st);
         // cargo dinamicamente estructura en memoria
         st = (rge *) calloc(nitems,sizeof(rge));
         if ( st != NULL ) {
            fp = fopen(ESTRUCTURA,"r");
//          printf("leo items\n");
            i=0;
            reglen=0L;
            while ( fscanf(fp,"%s\t%d\n",(char *) &st[i].campo,&st[i].largo) != EOF ) {
//             printf("item# %d %s %d\n",i,st[i].campo,st[i].largo);
               reglen+=st[i].largo;
               i++;
            }
//          printf("fin leo, largo=%d nitems=%d st=%p\n",(int) reglen,(int) nitems,st);
            fclose(fp);
            printf("Definicion %s cargada satisfactoriamente en memoria\n",ESTRUCTURA);
         } else {
            printf("cargar(): Error en asignacion de memoria(1)!\n");
            ret=0;
         }
      } else {
         printf("cargar(): %s Contiene una definicion incompleta!\n",ESTRUCTURA);
         ret=0;
      }
   } else {
      printf("cargar(): %s no pudo ser abierto. Posiblemente aun no ha Definido Archivo.\n",ESTRUCTURA);
      ret=0;
   }
   return ret;
}

// descarga de la memoria la estructura de campos y cantidad de campos
void descargar() {
   nitems = -1;
   reglen = -1L;
   if ( st != NULL ) {
      free(st);
      st = NULL;
   }
}

// el nombre de un campo debe contar con -al menos- 1 caracter, 
// no debe tener \t intermedios
// no puede superar un largo maximo de MAXLENCMP caracteres
int validarcampo(char *cmp) {
   int ret=1;
   if ( cmp == NULL ) {
      printf("Debe Ingresar Campo\n");
      ret=0;
   } else if ( strlen(cmp) < 1 ) {
      printf("Todo Campo debe tener -al menos- 1 caracter\n");
      ret=0;
   } else if ( strlen(cmp) > MAXLENCMP ) {
      printf("Todo Campo no puede superar los %d caracteres\n",MAXLENCMP);
      ret=0;
   } else {
      int i;
      for(i=0;i<strlen(cmp);i++) if ( cmp[i] == '\t' ) cmp[i] = ' ';
   }
   return ret;
}

// devuelve true si los campos estan cargados en memoria
int estacargado() {
   return ( nitems > 1 && st != NULL && reglen > 1L );
}

int puedotrabajar() {
   if ( !estacargado() ) {
      printf("Debe Definir Archivo para poder trabajar\n");
      return 0;
   } else return 1;
}

