/*

 UNLu
 Departamento de Ciencias Basicas
 Division Estadistica y Sistemas
 Licenciatura en Sistemas de Informacion
 11411 Base de Datos
 Lic. Guillermo Cherencio

 Trabajo Practico I "Listado Especifico - Listado Generico"
 Ejercicio I, II, III
 Usando compilador GNU C/C++ GCC for Windows (cygwin)
 Libreria de funciones para manejo de consola
 
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libconsola.h"

#define MAXSTRING 255  // largo maximo (en digitos) de strings
#define MAXINT 4     // largo maximo (en digitos) de valores enteros


/************************************************************************************
  COMIENZO LIBRERIA
************************************************************************************/
// prompt e ingreso de entero
int getIntP(char *prompt) {
   printf(prompt);
   return getInt();
}

// se toma el ingreso por stdin de un entero hasta presionar intro o bien llegar al maximo de MAXINT digitos
int getInt() {
   char c;
   char *num = (char *) calloc(MAXINT+1,1);
   int n=0,ret;
   for(;n<=MAXINT;n++) num[n] = '\0';
   n=0;
   do {
      c = (char) getc(stdin);
//printf("getInt() car=%d\n",c);
      if ( (c >= '0' && c <= '9') || c == '-' || c == '+' ) num[n++] = c;
   } while(c != 10 && n < MAXINT);
   while ( c != 10 ) c = (char) getc(stdin); // fue truncado por largo excesivo, ignoro el resto de caracteres tipeados
   fflush(stdin);
   ret=atoi(num);
   free(num);
   return ret;
}

// prompt e ingreso de string
char *getStringP(char *prompt) {
   printf(prompt);
   return getString();
}

// se toma el ingreso por stdin de un string hasta presionar intro o bien llegar al maximo de MAXSTRING digitos
char *getString() {
   char c;
   char *buf = (char *) calloc(MAXSTRING+1,1);
   int n=0;
   for(;n<=MAXSTRING;n++) buf[n] = '\0';
   n=0;
   do {
      c = (char) getc(stdin);
//printf("getString() car=%d\n",c);
      if ( c != 10 && c != 13 ) buf[n++] = c;
   } while(c != 10 && c != 13 && n < MAXSTRING);
   while ( c != 10 ) c = (char) getc(stdin); // fue truncado por largo excesivo, ignoro el resto de caracteres tipeados
   fflush(stdin);
   return buf;
}

// devuelve true si el usuario responde afirmativamente (S o s), caso contrario, devuelve false
int preguntarSN(char *msg) {
   char *msgcat = (char *) calloc(strlen(msg)+10,1);
   char *rta;
   int ret;
   strcpy(msgcat,msg);
   strcat(msgcat," (S/N): ");
   rta = getStringP(msgcat);
   ret=((strcmp(rta,"S") == 0) || (strcmp(rta,"s") == 0));
   free(msgcat);
   free(rta);
   return ret;
}

// realiza menu de opciones y devuelve opcion elegida por el usuario
int smenu(char *titulo,char *opciones[]) {
  int op,i;
  do {
     op=0;i=0;
     printf("%s\n",titulo);
     if ( opciones != NULL ) for(;strlen(opciones[i]) > 0;i++) printf("%d. %s\n",i+1,opciones[i]);
     printf("99. Salir\n");
     op=getIntP("Ingrese su Opcion:");
     linea();
  } while(op != 99 && !(op >= 1 && op <= i));
  return op;
}
// realiza menu de opciones y ejecuta funcion asociada con cada opcion de menu
int menu(char *titulo,char *opciones[],void (*pfuncion[]) () ) {
  int op = smenu(titulo,opciones);
  // ejecuto funcion asociada a esta opcion utilizando puntero
  if ( op != 99 ) pfuncion[op-1]();
  linea();
  return op;
}

// imprime una linea de signos "=" en todo el ancho de la consola
void linea() {
   char linea[80];
   int i=0;
   for(;i<79;i++) linea[i] = '=';
   linea[i]='\0';
   printf("%s\n",linea);
}

/************************************************************************************
  FIN LIBRERIA
************************************************************************************/
