/*
Programacion I 2008 Primer Parcial
Programa: dl1.c
Autor: G. Cherencio
Utilizacion de librerias dinamicas en gcc
Programa que utiliza la libreria dinamica pruebadl (pruebadl1.c pruebadl2.c)
Bibliografia: "Program Library HOWTO", David A. Wheeler, Program-Library-HOWTO.pdf
Compilar como:

gcc -o dl1.exe dl1.c -ldl

*/
#include <stdio.h>
#include <dlfcn.h> // requerido para cargar,buscar simbolos y descargar libreria dinamica

int main(void) {
   void *libfp; // puntero a libreria
   double (*cosine)(double); // puntero a funcion 

   void (*funcion11)(void);
   char *error;
   // cargo libreria
   libfp = dlopen ("libpruebadl.so", RTLD_NOW);
   if (!libfp) {
      fprintf(stderr,"Error cargando libreria pruebadl.so\n");
      fprintf(stderr,dlerror());
      return 1;
   }
   // ubico funcion
   funcion11 = dlsym(libfp, "funcion11");
   if ((error = dlerror()) != NULL) {
      fprintf(stderr,"Error buscando funcion11\n");
      fprintf(stderr,dlerror());
      return 1;
   }

   // ejecuto funcion
   printf("voy a ejecutar funcion11()\n");
   (*funcion11)();

   // ubico otra funcion con igual prototipo (que esta implementada en otro source)
   funcion11 = dlsym(libfp, "funcion21");
   if ((error = dlerror()) != NULL) {
      fprintf(stderr,"Error buscando funcion21\n");
      fprintf(stderr,dlerror());
      return 1;
   }


   // ejecuto funcion
   printf("voy a ejecutar funcion21()\n");
   (*funcion11)();

   // libero libreria
   dlclose(libfp);
   return 0;
}
